From c66cdbb57f19212d1e0b72454901471a98d1485a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 20 2020 08:41:15 +0000
Subject: [PATCH 312/2232] Reduce duplication of function vs method c++ function shim


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 1bc2fd1..acc74d5 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -286,36 +286,25 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
         })
     }
     .unwrap_or(call);
-    let receiver_type = efn.receiver.as_ref().map(|receiver| &receiver.ident);
-    match receiver_type {
-        None => quote! {
-            #doc
-            pub fn #ident(#(#all_args,)*) #ret {
-                extern "C" {
-                    #decl
-                }
-                #trampolines
-                unsafe {
-                    #setup
-                    #expr
-                }
+    let function_shim = quote! {
+        #doc
+        pub fn #ident(#(#all_args,)*) #ret {
+            extern "C" {
+                #decl
             }
-        },
-        Some(receiver_type) => quote! {
-            impl #receiver_type {
-                #doc
-                pub fn #ident(#(#all_args,)*) #ret {
-                    extern "C" {
-                        #decl
-                    }
-                    #trampolines
-                    unsafe {
-                        #setup
-                        #expr
-                    }
-                }
+            #trampolines
+            unsafe {
+                #setup
+                #expr
             }
-        },
+        }
+    };
+    match &efn.receiver {
+        None => function_shim,
+        Some(receiver) => {
+            let receiver_type = &receiver.ident;
+            quote!(impl #receiver_type { #function_shim })
+        }
     }
 }
 

